/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         hxfstparse
#define yylex           hxfstlex
#define yyerror         hxfsterror
#define yydebug         hxfstdebug
#define yynerrs         hxfstnerrs

#define yylval          hxfstlval
#define yychar          hxfstchar
#define yylloc          hxfstlloc

/* Copy the first part of user declarations.  */
#line 1 "xfst-parser.yy" /* yacc.c:339  */

// Copyright (c) 2016 University of Helsinki
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 3 of the License, or (at your option) any later version.
// See the file COPYING included with this distribution for more
// information.

//! @file xfst-parser.yy
//!
//! @brief A parser for xfst
//!
//! @author Tommi A. Pirinen

#if HAVE_CONFIG_H
#  include <config.h>
#endif

#include <cstdlib>
#include <cstdio>

#include <string>
using std::string;

namespace hfst {
  class HfstTransducer;
}

#include "XfstCompiler.h"
#include "xfst-utils.h"

#define CHECK if (hfst::xfst::xfst_->get_fail_flag()) { YYABORT; }

// obligatory yacc stuff
extern int hxfstlineno;
void hxfsterror(const char *text);
int hxfstlex(void);


#line 117 "xfst-parser.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_HXFST_XFST_PARSER_HH_INCLUDED
# define YY_HXFST_XFST_PARSER_HH_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int hxfstdebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    APROPOS = 258,
    DESCRIBE = 259,
    ECHO_ = 260,
    SYSTEM = 261,
    QUIT = 262,
    HFST = 263,
    NAMETOKEN = 264,
    NAMECHAR = 265,
    GLOB = 266,
    PROTOTYPE = 267,
    DEFINE_NAME = 268,
    DEFINE_FUNCTION = 269,
    RANGE = 270,
    REDIRECT_IN = 271,
    REDIRECT_OUT = 272,
    SAVE_PROLOG = 273,
    FOR = 274,
    REVERSE = 275,
    VIEW = 276,
    LOADD = 277,
    PRINT_LABEL_COUNT = 278,
    TEST_OVERLAP = 279,
    TEST_NONNULL = 280,
    CONCATENATE = 281,
    LOADS = 282,
    INVERT = 283,
    PRINT_ALIASES = 284,
    PRINT_LABELS = 285,
    XFST_OPTIONAL = 286,
    PRINT_SHORTEST_STRING_SIZE = 287,
    READ_PROPS = 288,
    TEST_FUNCT = 289,
    PRINT_LABELMAPS = 290,
    SUBSTRING = 291,
    COMPOSE = 292,
    READ_SPACED = 293,
    TEST_UPPER_UNI = 294,
    COLLECT_EPSILON_LOOPS = 295,
    ZERO_PLUS = 296,
    INSPECT = 297,
    ROTATE = 298,
    PRINT_WORDS = 299,
    POP = 300,
    SAVE_SPACED = 301,
    DEFINE = 302,
    SHOW = 303,
    PRINT_LONGEST_STRING_SIZE = 304,
    TEST_EQ = 305,
    SORT = 306,
    SAVE_DEFINITIONS = 307,
    SAVE_DOT = 308,
    TEST_UPPER_BOUNDED = 309,
    COMPLETE = 310,
    PRINT_FILE_INFO = 311,
    INTERSECT = 312,
    END_SUB = 313,
    TURN = 314,
    PRINT_LIST = 315,
    SUBSTITUTE_SYMBOL = 316,
    APPLY_UP = 317,
    ONE_PLUS = 318,
    UNDEFINE = 319,
    EPSILON_REMOVE = 320,
    PRINT_RANDOM_WORDS = 321,
    CTRLD = 322,
    EXTRACT_UNAMBIGUOUS = 323,
    SEMICOLON = 324,
    PRINT_LOWER_WORDS = 325,
    READ_PROLOG = 326,
    CLEAR = 327,
    PRINT_SIGMA_COUNT = 328,
    SUBSTITUTE_NAMED = 329,
    PRINT_FLAGS = 330,
    SET = 331,
    NEGATE = 332,
    APPLY_DOWN = 333,
    PRINT_STACK = 334,
    SAVE_STACK = 335,
    PUSH = 336,
    TEST_LOWER_BOUNDED = 337,
    PRINT_DEFINED = 338,
    APPLY_MED = 339,
    SHOW_ALL = 340,
    PRINT_ARCCOUNT = 341,
    PRINT_SIZE = 342,
    TEST_NULL = 343,
    PRINT_RANDOM_UPPER = 344,
    PRINT_LONGEST_STRING = 345,
    UPPER_SIDE = 346,
    XFST_IGNORE = 347,
    TEST_UNAMBIGUOUS = 348,
    PRINT = 349,
    READ_TEXT = 350,
    UNLIST = 351,
    SUBSTITUTE_LABEL = 352,
    SAVE_DEFINITION = 353,
    ELIMINATE_FLAG = 354,
    EDIT_PROPS = 355,
    PRINT_UPPER_WORDS = 356,
    NAME = 357,
    EXTRACT_AMBIGUOUS = 358,
    DEFINE_ALIAS = 359,
    PRINT_RANDOM_LOWER = 360,
    CROSSPRODUCT = 361,
    COMPACT_SIGMA = 362,
    SOURCE = 363,
    AMBIGUOUS = 364,
    ELIMINATE_ALL = 365,
    PRINT_SIGMA = 366,
    PRINT_SHORTEST_STRING = 367,
    LEFT_PAREN = 368,
    PRINT_PROPS = 369,
    READ_REGEX = 370,
    DEFINE_LIST = 371,
    TEST_ID = 372,
    PRINT_LISTS = 373,
    TEST_SUBLANGUAGE = 374,
    TEST_LOWER_UNI = 375,
    COMPILE_REPLACE_UPPER = 376,
    CLEANUP = 377,
    ADD_PROPS = 378,
    PRINT_SIGMA_WORD_COUNT = 379,
    SHUFFLE = 380,
    COLON = 381,
    SAVE_TEXT = 382,
    DETERMINIZE = 383,
    SIGMA = 384,
    COMPILE_REPLACE_LOWER = 385,
    UNION = 386,
    PRINT_DIR = 387,
    LIST = 388,
    LOWER_SIDE = 389,
    MINIMIZE = 390,
    MINUS = 391,
    PRINT_NAME = 392,
    PRUNE_NET = 393,
    PUSH_DEFINED = 394,
    READ_LEXC = 395,
    READ_ATT = 396,
    TWOSIDED_FLAGS = 397,
    WRITE_ATT = 398,
    ASSERT = 399,
    LABEL_NET = 400,
    LOOKUP_OPTIMIZE = 401,
    REMOVE_OPTIMIZATION = 402,
    TEST_INFINITELY_AMBIGUOUS = 403,
    XFST_ERROR = 404,
    NEWLINE = 405,
    REGEX = 406,
    APPLY_INPUT = 407,
    APPLY_UP_SINGLE = 408,
    APPLY_DOWN_SINGLE = 409
  };
#endif
/* Tokens.  */
#define APROPOS 258
#define DESCRIBE 259
#define ECHO_ 260
#define SYSTEM 261
#define QUIT 262
#define HFST 263
#define NAMETOKEN 264
#define NAMECHAR 265
#define GLOB 266
#define PROTOTYPE 267
#define DEFINE_NAME 268
#define DEFINE_FUNCTION 269
#define RANGE 270
#define REDIRECT_IN 271
#define REDIRECT_OUT 272
#define SAVE_PROLOG 273
#define FOR 274
#define REVERSE 275
#define VIEW 276
#define LOADD 277
#define PRINT_LABEL_COUNT 278
#define TEST_OVERLAP 279
#define TEST_NONNULL 280
#define CONCATENATE 281
#define LOADS 282
#define INVERT 283
#define PRINT_ALIASES 284
#define PRINT_LABELS 285
#define XFST_OPTIONAL 286
#define PRINT_SHORTEST_STRING_SIZE 287
#define READ_PROPS 288
#define TEST_FUNCT 289
#define PRINT_LABELMAPS 290
#define SUBSTRING 291
#define COMPOSE 292
#define READ_SPACED 293
#define TEST_UPPER_UNI 294
#define COLLECT_EPSILON_LOOPS 295
#define ZERO_PLUS 296
#define INSPECT 297
#define ROTATE 298
#define PRINT_WORDS 299
#define POP 300
#define SAVE_SPACED 301
#define DEFINE 302
#define SHOW 303
#define PRINT_LONGEST_STRING_SIZE 304
#define TEST_EQ 305
#define SORT 306
#define SAVE_DEFINITIONS 307
#define SAVE_DOT 308
#define TEST_UPPER_BOUNDED 309
#define COMPLETE 310
#define PRINT_FILE_INFO 311
#define INTERSECT 312
#define END_SUB 313
#define TURN 314
#define PRINT_LIST 315
#define SUBSTITUTE_SYMBOL 316
#define APPLY_UP 317
#define ONE_PLUS 318
#define UNDEFINE 319
#define EPSILON_REMOVE 320
#define PRINT_RANDOM_WORDS 321
#define CTRLD 322
#define EXTRACT_UNAMBIGUOUS 323
#define SEMICOLON 324
#define PRINT_LOWER_WORDS 325
#define READ_PROLOG 326
#define CLEAR 327
#define PRINT_SIGMA_COUNT 328
#define SUBSTITUTE_NAMED 329
#define PRINT_FLAGS 330
#define SET 331
#define NEGATE 332
#define APPLY_DOWN 333
#define PRINT_STACK 334
#define SAVE_STACK 335
#define PUSH 336
#define TEST_LOWER_BOUNDED 337
#define PRINT_DEFINED 338
#define APPLY_MED 339
#define SHOW_ALL 340
#define PRINT_ARCCOUNT 341
#define PRINT_SIZE 342
#define TEST_NULL 343
#define PRINT_RANDOM_UPPER 344
#define PRINT_LONGEST_STRING 345
#define UPPER_SIDE 346
#define XFST_IGNORE 347
#define TEST_UNAMBIGUOUS 348
#define PRINT 349
#define READ_TEXT 350
#define UNLIST 351
#define SUBSTITUTE_LABEL 352
#define SAVE_DEFINITION 353
#define ELIMINATE_FLAG 354
#define EDIT_PROPS 355
#define PRINT_UPPER_WORDS 356
#define NAME 357
#define EXTRACT_AMBIGUOUS 358
#define DEFINE_ALIAS 359
#define PRINT_RANDOM_LOWER 360
#define CROSSPRODUCT 361
#define COMPACT_SIGMA 362
#define SOURCE 363
#define AMBIGUOUS 364
#define ELIMINATE_ALL 365
#define PRINT_SIGMA 366
#define PRINT_SHORTEST_STRING 367
#define LEFT_PAREN 368
#define PRINT_PROPS 369
#define READ_REGEX 370
#define DEFINE_LIST 371
#define TEST_ID 372
#define PRINT_LISTS 373
#define TEST_SUBLANGUAGE 374
#define TEST_LOWER_UNI 375
#define COMPILE_REPLACE_UPPER 376
#define CLEANUP 377
#define ADD_PROPS 378
#define PRINT_SIGMA_WORD_COUNT 379
#define SHUFFLE 380
#define COLON 381
#define SAVE_TEXT 382
#define DETERMINIZE 383
#define SIGMA 384
#define COMPILE_REPLACE_LOWER 385
#define UNION 386
#define PRINT_DIR 387
#define LIST 388
#define LOWER_SIDE 389
#define MINIMIZE 390
#define MINUS 391
#define PRINT_NAME 392
#define PRUNE_NET 393
#define PUSH_DEFINED 394
#define READ_LEXC 395
#define READ_ATT 396
#define TWOSIDED_FLAGS 397
#define WRITE_ATT 398
#define ASSERT 399
#define LABEL_NET 400
#define LOOKUP_OPTIMIZE 401
#define REMOVE_OPTIMIZATION 402
#define TEST_INFINITELY_AMBIGUOUS 403
#define XFST_ERROR 404
#define NEWLINE 405
#define REGEX 406
#define APPLY_INPUT 407
#define APPLY_UP_SINGLE 408
#define APPLY_DOWN_SINGLE 409

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 51 "xfst-parser.yy" /* yacc.c:355  */

    char* name;
    char* text;
    char** list;
    char* file;
    void* nothing;

#line 473 "xfst-parser.cc" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE hxfstlval;
extern YYLTYPE hxfstlloc;
int hxfstparse (void);

#endif /* !YY_HXFST_XFST_PARSER_HH_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 504 "xfst-parser.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  350
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   851

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  155
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  10
/* YYNRULES -- Number of rules.  */
#define YYNRULES  262
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  539

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   409

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,    99,    99,   100,   103,   104,   107,   116,   120,   125,
     128,   131,   135,   144,   148,   151,   154,   158,   167,   171,
     175,   184,   188,   191,   195,   199,   203,   208,   213,   218,
     223,   230,   234,   239,   244,   248,   252,   256,   261,   265,
     269,   272,   275,   279,   282,   285,   288,   292,   296,   301,
     304,   308,   312,   316,   320,   325,   329,   334,   338,   344,
     353,   357,   360,   364,   367,   370,   373,   376,   379,   382,
     385,   388,   391,   394,   397,   400,   404,   407,   410,   413,
     416,   419,   422,   425,   428,   431,   434,   437,   441,   446,
     451,   457,   466,   469,   478,   488,   491,   500,   503,   512,
     516,   525,   528,   537,   540,   549,   552,   556,   565,   568,
     577,   580,   589,   593,   602,   605,   615,   620,   630,   635,
     644,   647,   657,   662,   672,   677,   681,   692,   701,   704,
     719,   729,   733,   744,   752,   755,   769,   779,   783,   794,
     802,   805,   818,   827,   831,   841,   849,   852,   865,   874,
     878,   888,   896,   899,   912,   921,   925,   935,   943,   946,
     959,   968,   972,   981,   984,   988,   991,  1000,  1004,  1013,
    1016,  1025,  1028,  1038,  1047,  1050,  1054,  1063,  1066,  1075,
    1078,  1088,  1092,  1101,  1104,  1108,  1112,  1116,  1120,  1123,
    1126,  1130,  1139,  1148,  1151,  1160,  1163,  1172,  1176,  1185,
    1188,  1197,  1200,  1204,  1213,  1217,  1221,  1225,  1229,  1233,
    1237,  1241,  1245,  1249,  1252,  1256,  1259,  1268,  1277,  1288,
    1291,  1294,  1297,  1300,  1303,  1306,  1309,  1312,  1315,  1318,
    1321,  1324,  1327,  1330,  1333,  1336,  1339,  1342,  1345,  1348,
    1351,  1354,  1357,  1360,  1363,  1366,  1369,  1372,  1375,  1378,
    1389,  1389,  1391,  1413,  1416,  1421,  1443,  1448,  1474,  1493,
    1497,  1502,  1524
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "APROPOS", "DESCRIBE", "ECHO_", "SYSTEM",
  "QUIT", "HFST", "NAMETOKEN", "NAMECHAR", "GLOB", "PROTOTYPE",
  "DEFINE_NAME", "DEFINE_FUNCTION", "RANGE", "REDIRECT_IN", "REDIRECT_OUT",
  "SAVE_PROLOG", "FOR", "REVERSE", "VIEW", "LOADD", "PRINT_LABEL_COUNT",
  "TEST_OVERLAP", "TEST_NONNULL", "CONCATENATE", "LOADS", "INVERT",
  "PRINT_ALIASES", "PRINT_LABELS", "XFST_OPTIONAL",
  "PRINT_SHORTEST_STRING_SIZE", "READ_PROPS", "TEST_FUNCT",
  "PRINT_LABELMAPS", "SUBSTRING", "COMPOSE", "READ_SPACED",
  "TEST_UPPER_UNI", "COLLECT_EPSILON_LOOPS", "ZERO_PLUS", "INSPECT",
  "ROTATE", "PRINT_WORDS", "POP", "SAVE_SPACED", "DEFINE", "SHOW",
  "PRINT_LONGEST_STRING_SIZE", "TEST_EQ", "SORT", "SAVE_DEFINITIONS",
  "SAVE_DOT", "TEST_UPPER_BOUNDED", "COMPLETE", "PRINT_FILE_INFO",
  "INTERSECT", "END_SUB", "TURN", "PRINT_LIST", "SUBSTITUTE_SYMBOL",
  "APPLY_UP", "ONE_PLUS", "UNDEFINE", "EPSILON_REMOVE",
  "PRINT_RANDOM_WORDS", "CTRLD", "EXTRACT_UNAMBIGUOUS", "SEMICOLON",
  "PRINT_LOWER_WORDS", "READ_PROLOG", "CLEAR", "PRINT_SIGMA_COUNT",
  "SUBSTITUTE_NAMED", "PRINT_FLAGS", "SET", "NEGATE", "APPLY_DOWN",
  "PRINT_STACK", "SAVE_STACK", "PUSH", "TEST_LOWER_BOUNDED",
  "PRINT_DEFINED", "APPLY_MED", "SHOW_ALL", "PRINT_ARCCOUNT", "PRINT_SIZE",
  "TEST_NULL", "PRINT_RANDOM_UPPER", "PRINT_LONGEST_STRING", "UPPER_SIDE",
  "XFST_IGNORE", "TEST_UNAMBIGUOUS", "PRINT", "READ_TEXT", "UNLIST",
  "SUBSTITUTE_LABEL", "SAVE_DEFINITION", "ELIMINATE_FLAG", "EDIT_PROPS",
  "PRINT_UPPER_WORDS", "NAME", "EXTRACT_AMBIGUOUS", "DEFINE_ALIAS",
  "PRINT_RANDOM_LOWER", "CROSSPRODUCT", "COMPACT_SIGMA", "SOURCE",
  "AMBIGUOUS", "ELIMINATE_ALL", "PRINT_SIGMA", "PRINT_SHORTEST_STRING",
  "LEFT_PAREN", "PRINT_PROPS", "READ_REGEX", "DEFINE_LIST", "TEST_ID",
  "PRINT_LISTS", "TEST_SUBLANGUAGE", "TEST_LOWER_UNI",
  "COMPILE_REPLACE_UPPER", "CLEANUP", "ADD_PROPS",
  "PRINT_SIGMA_WORD_COUNT", "SHUFFLE", "COLON", "SAVE_TEXT", "DETERMINIZE",
  "SIGMA", "COMPILE_REPLACE_LOWER", "UNION", "PRINT_DIR", "LIST",
  "LOWER_SIDE", "MINIMIZE", "MINUS", "PRINT_NAME", "PRUNE_NET",
  "PUSH_DEFINED", "READ_LEXC", "READ_ATT", "TWOSIDED_FLAGS", "WRITE_ATT",
  "ASSERT", "LABEL_NET", "LOOKUP_OPTIMIZE", "REMOVE_OPTIMIZATION",
  "TEST_INFINITELY_AMBIGUOUS", "XFST_ERROR", "NEWLINE", "REGEX",
  "APPLY_INPUT", "APPLY_UP_SINGLE", "APPLY_DOWN_SINGLE", "$accept",
  "XFST_SCRIPT", "COMMAND_LIST", "COMMAND", "END_COMMAND",
  "COMMAND_SEQUENCE", "NAMETOKEN_LIST", "QUOTED_NAMETOKEN_LIST", "LABEL",
  "LABEL_LIST", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409
};
# endif

#define YYPACT_NINF -264

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-264)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     697,  -146,  -146,  -264,  -264,  -264,  -264,  -146,  -144,  -123,
       8,  -146,  -146,    28,    70,  -146,  -146,  -146,   357,  -146,
      82,    72,  -146,   149,    32,  -146,    35,  -146,  -146,   359,
    -146,  -146,  -146,  -146,  -146,   113,  -146,   156,    40,   171,
    -146,  -146,   181,   114,  -146,  -146,   213,  -146,  -146,    71,
      74,    44,  -146,   125,  -146,   128,  -146,   129,    53,  -146,
     222,   126,   226,   130,  -146,   146,   235,   147,  -146,   236,
     158,  -146,   152,   161,  -146,   167,   254,  -146,  -146,  -146,
     172,   368,   168,   182,   190,   193,  -146,   178,   227,  -146,
     348,   197,  -146,  -146,   365,  -146,  -146,   208,   275,   210,
      -4,  -146,   295,  -146,  -146,  -146,  -146,   374,   217,  -146,
     298,  -146,  -146,  -146,  -146,    -9,   369,  -146,  -146,  -146,
     302,  -146,    73,   370,   373,  -146,   237,   410,  -146,  -146,
    -146,  -264,  -264,  -146,  -146,   395,   545,  -264,  -264,  -264,
    -264,  -264,  -264,  -264,  -146,  -146,  -264,  -264,  -264,  -146,
    -146,  -264,  -264,  -264,  -264,   231,  -146,  -264,  -146,  -264,
    -146,  -146,  -264,  -264,  -146,  -264,  -146,  -264,  -264,  -146,
    -264,  -264,  -146,  -146,    75,  -264,  -264,  -264,  -264,  -264,
     241,  -146,  -264,  -264,  -146,  -264,  -146,  -146,  -264,  -264,
    -264,  -146,  -264,  -146,  -146,  -264,  -264,  -264,  -146,  -264,
    -264,  -264,   309,  -264,   346,  -146,  -146,   125,  -264,  -264,
      97,  -264,   256,  -146,  -264,  -264,   273,  -146,  -264,  -146,
    -264,  -264,  -146,  -264,   377,  -146,  -264,   388,  -264,  -146,
    -146,   125,  -146,  -264,  -146,  -264,  -146,  -264,  -146,  -146,
     125,  -264,  -146,  -146,  -264,  -146,  -146,  -264,  -264,   276,
    -146,  -264,  -146,  -264,  -264,  -264,  -264,  -146,  -146,  -264,
    -146,  -146,   141,  -146,   272,  -264,   352,   196,  -146,  -264,
     288,  -146,  -264,  -146,  -264,   127,   307,  -146,  -264,  -264,
    -264,  -146,  -264,  -264,  -146,  -146,  -264,  -146,  -264,  -146,
    -146,  -264,  -146,  -264,    84,  -264,  -146,  -264,  -264,  -264,
    -264,  -264,  -146,   143,  -146,  -146,  -264,  -264,  -146,  -264,
    -264,  -264,  -264,  -264,   327,  -146,  -264,   246,  -264,  -264,
    -264,  -146,  -264,  -264,  -146,  -264,   249,   343,  -146,  -264,
     131,  -146,  -264,  -146,  -146,  -146,  -146,  -146,  -146,  -146,
    -146,  -146,  -146,  -146,  -146,  -264,  -264,  -264,  -264,  -264,
    -264,  -264,  -264,  -264,  -264,  -264,  -264,  -146,  -264,  -264,
    -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264,
     328,  -146,  -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264,
    -264,  -146,  -264,  -264,   392,  -264,  -264,   142,  -264,   331,
    -146,  -264,  -264,   332,  -146,  -264,  -264,  -264,  -264,   393,
    -264,  -146,  -264,  -264,   350,  -264,  -264,  -264,  -264,  -264,
     353,  -264,  -264,  -264,  -264,   333,  -146,  -264,  -264,  -264,
    -264,  -264,  -264,  -264,  -264,  -264,   394,   182,  -264,  -146,
     334,  -264,  -264,   336,  -146,  -264,  -264,  -264,  -264,   125,
      57,   337,  -146,  -264,  -264,  -264,  -264,  -264,  -264,  -264,
    -264,  -264,  -146,  -264,  -264,  -264,  -264,  -264,  -264,  -146,
    -264,  -264,  -146,   106,  -264,  -264,  -146,  -264,  -264,  -264,
     396,  -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264,
    -264,  -264,  -264,  -264,  -264,  -264,  -146,  -264,  -264,  -264,
    -146,  -264,  -146,  -264,  -264,  -146,  -264,  -264,  -146,  -264,
    -264,  -264,  -146,  -264,  -264,  -264,  -146,  -264,  -146,  -264,
    -146,  -264,  -264,   355,  -264,  -264,  -264,  -146,  -264,  -264,
    -264,  -264,  -264,  -146,  -264,  -146,  -264,  -264,  -264,  -264,
    -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
     251,   251,   251,    53,    57,    54,    55,   251,    31,     0,
     251,   251,   251,     0,   251,   251,   251,   251,     0,   251,
     251,   251,   251,   251,   251,   251,     0,   251,   251,     0,
     251,   251,   251,   251,   251,   251,   251,   251,     0,   251,
     251,   251,   251,   251,   251,   251,   251,   251,   251,     0,
       0,   251,   251,     0,   251,   251,   251,   251,   251,   251,
     251,     0,   251,     0,   251,   251,   251,     0,   251,   251,
       0,   251,   251,   251,   251,   251,   251,   251,   251,   251,
     251,     0,     0,     0,     0,     0,   251,   251,     0,   251,
       0,   251,   251,   251,     0,   251,   251,   251,   251,   251,
       0,   251,   251,   251,   251,   251,   251,     0,   251,   251,
     251,   251,   251,   251,   251,   251,     0,   251,   251,   251,
     251,   251,   251,     0,     0,   251,   251,     0,   251,   251,
     251,    66,   250,   251,   251,     0,     2,     5,   248,    38,
      39,   249,    32,    33,   251,   251,   193,   239,    58,   251,
     251,   110,    73,    71,   222,   251,   251,   232,   251,    92,
     251,   251,   108,   238,   251,   124,   251,   199,    64,   251,
     243,   221,   251,   251,     0,    70,    49,   237,   231,    45,
     251,   251,   152,    41,   251,   195,   251,   251,   118,    63,
     242,   251,   189,   251,   251,   183,    69,   220,   251,   103,
     230,    44,   251,   258,     0,   251,   251,     9,   236,   256,
     251,   227,   251,   251,   158,    26,   251,   251,   128,   251,
     201,    40,   251,   171,     0,   251,   105,     0,   235,   251,
     251,    14,   251,   179,   251,    67,   251,    97,   251,   251,
       0,    61,   251,   251,    95,   251,   251,   177,    72,   251,
     251,   146,   251,   116,   234,   229,    75,   251,   251,   163,
     251,   251,     0,   251,   260,   262,     0,   251,   251,     8,
     251,   251,   140,   251,    25,     0,   251,   251,   134,   224,
      50,   251,    24,    52,   251,   251,   169,   251,   122,   251,
     251,   165,   251,   202,     0,    65,   251,   114,    74,    68,
     247,   219,   251,     0,   251,   251,   174,   240,   251,   197,
     226,   241,   246,   244,   251,   251,   101,     0,   233,   225,
     223,   251,   120,   228,   251,    43,   251,     0,   251,    62,
     251,   251,   215,   251,   251,   251,   251,   251,   251,   251,
     251,   251,   251,   251,   251,   245,    22,    23,    11,    16,
       1,     3,     4,   192,   191,    37,   109,   251,    47,    46,
      91,   106,   107,   123,   198,   180,   206,   205,   255,   207,
     251,   251,   151,   154,   194,    60,   117,   188,   181,   182,
     102,   251,   112,   257,     0,    12,    10,     0,    34,   251,
     251,   157,   160,   251,   251,   127,   130,   200,   170,     0,
     104,   251,    17,    15,     0,   178,   190,    96,    19,    20,
       0,    94,    93,   175,   176,   251,   251,   145,   148,   115,
     161,   162,   209,   208,   210,    35,     0,     0,   261,   251,
     251,   187,    51,   251,   251,   139,   142,    36,   254,     0,
     251,   251,   251,   133,   136,    56,   167,   168,   121,   164,
     166,   203,   251,   113,     6,     7,   172,   173,   196,   251,
      99,   100,   251,     0,   119,    42,   251,   211,   213,   214,
       0,   217,   216,    85,    83,    77,    82,    76,    81,    79,
      84,    87,    78,    86,    80,    48,   251,   149,   153,   111,
     251,    13,   251,   155,   159,   251,   125,   129,   251,    59,
      18,    21,   251,   143,   147,   259,   251,   186,   251,   185,
     251,   137,   141,     0,   252,   253,    27,   251,   131,   135,
     204,    98,    30,   251,   212,   251,   150,    90,   156,   126,
      88,   144,    89,   184,   138,    28,   132,    29,   218
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -264,  -264,  -264,   271,    -1,  -264,   187,  -264,  -263,  -264
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   135,   136,   137,   138,   440,   174,   204,   265,   266
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint16 yytable[] =
{
     139,   140,   314,   428,   132,   209,   141,   142,   315,   146,
     147,   148,   292,   151,   152,   153,   154,   144,   157,   159,
     162,   163,   165,   167,   168,   145,   170,   171,   143,   175,
     176,   177,   178,   179,   182,   183,   185,   149,   188,   189,
     190,   192,   195,   196,   197,   199,   200,   201,   166,   186,
     207,   208,   169,   211,   214,   215,   218,   220,   221,   223,
     205,   226,   219,   228,   231,   233,   514,   235,   237,   240,
     241,   244,   247,   248,   251,   253,   254,   255,   256,   259,
     202,   160,   324,   203,   368,   269,   272,   150,   274,   161,
     278,   279,   280,   368,   282,   283,   286,   288,   291,   158,
     295,   297,   298,   299,   300,   301,   368,   306,   307,   309,
     310,   311,   312,   313,   316,   368,   318,   319,   320,   322,
     323,   325,   180,   193,   329,   332,   515,   345,   346,   347,
     181,   194,   348,   349,   209,   224,   438,   212,   216,   227,
     470,   132,   369,   353,   354,   213,   217,   293,   355,   356,
     368,   368,   368,   452,   358,   359,   234,   360,   132,   361,
     362,   242,   229,   363,   506,   364,   164,   238,   365,   243,
     245,   366,   367,   184,   239,   523,   249,   263,   246,   372,
     373,   257,   132,   374,   250,   375,   376,   270,   187,   258,
     377,   264,   378,   379,   132,   271,   206,   380,   191,   267,
     491,   382,   268,   132,   385,   386,   276,   132,   424,   388,
     455,   391,   392,   429,   277,   395,   396,   284,   397,   289,
     132,   398,   132,   132,   400,   285,   304,   290,   402,   403,
     198,   405,   132,   406,   305,   407,   273,   408,   409,   222,
     210,   411,   412,   225,   413,   414,   330,   132,   417,   418,
     370,   419,   232,   236,   331,   209,   420,   421,   371,   422,
     423,   462,   425,   132,   132,   389,   431,   432,   262,   435,
     436,   252,   437,   390,   439,   443,   444,   132,   132,   132,
     445,   132,   393,   446,   447,   415,   448,   294,   449,   450,
     394,   451,   287,   416,   303,   453,   132,   433,   230,   132,
     357,   454,   132,   456,   457,   434,   132,   458,   132,   430,
     327,   132,   296,   460,   461,   308,   441,   132,   466,   321,
     464,   132,   132,   465,   442,   467,   381,   469,   132,   471,
     472,   132,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   459,   486,   132,   132,   492,   495,
     502,   508,   368,   510,   517,   383,   485,   275,   132,   368,
     132,   264,   368,   132,   368,   384,   155,   132,   172,   487,
     488,   427,   132,   156,   281,   173,   132,   260,   317,   326,
     489,   132,   328,   209,   261,   132,   132,   132,   493,   494,
     302,   132,   496,   497,   387,   350,   399,   401,   426,   132,
     499,   490,   498,   505,   132,   525,   132,   352,   500,     0,
     468,   501,     0,   535,   503,   504,     0,     0,   404,     0,
       0,     0,     0,   132,     0,   132,   132,   410,   507,   509,
       0,     0,   511,   512,   333,   334,     0,     0,   132,   516,
     518,   519,     0,     0,   335,   132,     0,     0,   132,   336,
       0,   520,   132,     0,     0,     0,     0,   132,   521,   132,
     337,   522,     0,     0,   338,   524,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   132,   132,     0,
       0,   132,   132,   132,   132,   526,   132,   132,     0,   527,
       0,   528,   339,     0,   529,     0,     0,   530,   340,     0,
       0,   531,     0,   341,   463,   532,     0,   533,     0,   534,
       0,     0,     0,     0,     0,     0,   536,     0,     0,     0,
       0,     0,   537,     0,   538,     0,     0,   342,     0,   343,
     344,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     1,     2,
       3,     4,     5,     6,     7,     0,     0,     0,     8,     9,
       0,     0,     0,    10,     0,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,     0,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,     0,    48,    49,    50,    51,    52,    53,
      54,    55,   351,    56,     0,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,   513,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,     0,    99,
     100,     0,   101,   102,   103,   104,   105,   106,   107,   108,
     109,     0,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,     0,   132,     0,     0,   133,   134,
       1,     2,     3,     4,     5,     6,     7,     0,     0,     0,
       8,     9,     0,     0,     0,    10,     0,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,     0,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,     0,    48,    49,    50,    51,
      52,    53,    54,    55,     0,    56,     0,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,     0,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
       0,    99,   100,     0,   101,   102,   103,   104,   105,   106,
     107,   108,   109,     0,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,     0,   132,     0,     0,
     133,   134
};

static const yytype_int16 yycheck[] =
{
       1,     2,    11,   266,   150,     9,     7,   151,    17,    10,
      11,    12,    16,    14,    15,    16,    17,     9,    19,    20,
      21,    22,    23,    24,    25,    17,    27,    28,   151,    30,
      31,    32,    33,    34,    35,    36,    37,     9,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    16,     9,
      51,    52,    17,    54,    55,    56,    57,    58,    59,    60,
      16,    62,     9,    64,    65,    66,     9,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
       9,     9,     9,     9,     9,    86,    87,    17,    89,    17,
      91,    92,    93,     9,    95,    96,    97,    98,    99,    17,
     101,   102,   103,   104,   105,   106,     9,   108,   109,   110,
     111,   112,   113,   114,   115,     9,   117,   118,   119,   120,
     121,   122,     9,     9,   125,   126,    69,   128,   129,   130,
      17,    17,   133,   134,     9,     9,     9,     9,     9,     9,
       9,   150,    67,   144,   145,    17,    17,   151,   149,   150,
       9,     9,     9,    69,   155,   156,     9,   158,   150,   160,
     161,     9,    16,   164,   427,   166,    17,     9,   169,    17,
       9,   172,   173,    17,    16,    69,     9,     9,    17,   180,
     181,     9,   150,   184,    17,   186,   187,     9,    17,    17,
     191,     9,   193,   194,   150,    17,   152,   198,    17,     9,
      58,   202,     9,   150,   205,   206,     9,   150,    67,   210,
      67,   212,   213,    17,    17,   216,   217,     9,   219,     9,
     150,   222,   150,   150,   225,    17,     9,    17,   229,   230,
      17,   232,   150,   234,    17,   236,     9,   238,   239,    17,
      53,   242,   243,    17,   245,   246,     9,   150,   249,   250,
       9,   252,    17,    17,    17,     9,   257,   258,    17,   260,
     261,    15,   263,   150,   150,     9,   267,   268,    81,   270,
     271,    17,   273,    17,   275,   276,   277,   150,   150,   150,
     281,   150,     9,   284,   285,     9,   287,   100,   289,   290,
      17,   292,    17,    17,   107,   296,   150,     9,   152,   150,
      69,   302,   150,   304,   305,    17,   150,   308,   150,   113,
     123,   150,    17,   314,   315,    17,     9,   150,    69,    17,
     321,   150,   150,   324,    17,   326,    17,   328,   150,   330,
     331,   150,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    17,    17,   150,   150,    17,    17,
      17,    17,     9,    17,    17,     9,   357,     9,   150,     9,
     150,     9,     9,   150,     9,    19,     9,   150,     9,   370,
     371,    19,   150,    16,     9,    16,   150,     9,     9,     9,
     381,   150,     9,     9,    16,   150,   150,   150,   389,   390,
      16,   150,   393,   394,   207,     0,    19,     9,   126,   150,
     401,     9,     9,     9,   150,     9,   150,   136,    58,    -1,
      67,    58,    -1,    58,   415,   416,    -1,    -1,   231,    -1,
      -1,    -1,    -1,   150,    -1,   150,   150,   240,   429,   430,
      -1,    -1,   433,   434,    24,    25,    -1,    -1,   150,   440,
     441,   442,    -1,    -1,    34,   150,    -1,    -1,   150,    39,
      -1,   452,   150,    -1,    -1,    -1,    -1,   150,   459,   150,
      50,   462,    -1,    -1,    54,   466,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   150,   150,    -1,
      -1,   150,   150,   150,   150,   486,   150,   150,    -1,   490,
      -1,   492,    82,    -1,   495,    -1,    -1,   498,    88,    -1,
      -1,   502,    -1,    93,   317,   506,    -1,   508,    -1,   510,
      -1,    -1,    -1,    -1,    -1,    -1,   517,    -1,    -1,    -1,
      -1,    -1,   523,    -1,   525,    -1,    -1,   117,    -1,   119,
     120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     9,    -1,    -1,    -1,    13,    14,
      -1,    -1,    -1,    18,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    -1,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,   439,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,    -1,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,   123,   124,
     125,    -1,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,    -1,   150,    -1,    -1,   153,   154,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      13,    14,    -1,    -1,    -1,    18,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    -1,    59,    60,    61,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,   114,   115,    -1,   117,   118,   119,   120,   121,   122,
     123,   124,   125,    -1,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,    -1,   150,    -1,    -1,
     153,   154
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,     9,    13,    14,
      18,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    59,    60,
      61,    62,    63,    64,    65,    66,    68,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   114,
     115,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   150,   153,   154,   156,   157,   158,   159,   159,
     159,   159,   151,   151,     9,    17,   159,   159,   159,     9,
      17,   159,   159,   159,   159,     9,    16,   159,    17,   159,
       9,    17,   159,   159,    17,   159,    16,   159,   159,    17,
     159,   159,     9,    16,   161,   159,   159,   159,   159,   159,
       9,    17,   159,   159,    17,   159,     9,    17,   159,   159,
     159,    17,   159,     9,    17,   159,   159,   159,    17,   159,
     159,   159,     9,     9,   162,    16,   152,   159,   159,     9,
     161,   159,     9,    17,   159,   159,     9,    17,   159,     9,
     159,   159,    17,   159,     9,    17,   159,     9,   159,    16,
     152,   159,    17,   159,     9,   159,    17,   159,     9,    16,
     159,   159,     9,    17,   159,     9,    17,   159,   159,     9,
      17,   159,    17,   159,   159,   159,   159,     9,    17,   159,
       9,    16,   161,     9,     9,   163,   164,     9,     9,   159,
       9,    17,   159,     9,   159,     9,     9,    17,   159,   159,
     159,     9,   159,   159,     9,    17,   159,    17,   159,     9,
      17,   159,    16,   151,   161,   159,    17,   159,   159,   159,
     159,   159,    16,   161,     9,    17,   159,   159,    17,   159,
     159,   159,   159,   159,    11,    17,   159,     9,   159,   159,
     159,    17,   159,   159,     9,   159,     9,   161,     9,   159,
       9,    17,   159,    24,    25,    34,    39,    50,    54,    82,
      88,    93,   117,   119,   120,   159,   159,   159,   159,   159,
       0,    67,   158,   159,   159,   159,   159,    69,   159,   159,
     159,   159,   159,   159,   159,   159,   159,   159,     9,    67,
       9,    17,   159,   159,   159,   159,   159,   159,   159,   159,
     159,    17,   159,     9,    19,   159,   159,   161,   159,     9,
      17,   159,   159,     9,    17,   159,   159,   159,   159,    19,
     159,     9,   159,   159,   161,   159,   159,   159,   159,   159,
     161,   159,   159,   159,   159,     9,    17,   159,   159,   159,
     159,   159,   159,   159,    67,   159,   126,    19,   163,    17,
     113,   159,   159,     9,    17,   159,   159,   159,     9,   159,
     160,     9,    17,   159,   159,   159,   159,   159,   159,   159,
     159,   159,    69,   159,   159,    67,   159,   159,   159,    17,
     159,   159,    15,   161,   159,   159,    69,   159,    67,   159,
       9,   159,   159,   159,   159,   159,   159,   159,   159,   159,
     159,   159,   159,   159,   159,   159,    17,   159,   159,   159,
       9,    58,    17,   159,   159,    17,   159,   159,     9,   159,
      58,    58,    17,   159,   159,     9,   163,   159,    17,   159,
      17,   159,   159,   161,     9,    69,   159,    17,   159,   159,
     159,   159,   159,    69,   159,     9,   159,   159,   159,   159,
     159,   159,   159,   159,   159,    58,   159,   159,   159
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   155,   156,   156,   157,   157,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     159,   159,   160,   160,   160,   161,   161,   162,   162,   163,
     163,   164,   164
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     1,     3,     3,     2,     2,
       3,     2,     3,     4,     2,     3,     2,     3,     4,     3,
       3,     4,     2,     2,     2,     2,     2,     4,     5,     5,
       4,     1,     2,     2,     3,     3,     3,     3,     2,     2,
       2,     2,     3,     2,     2,     2,     3,     3,     4,     2,
       2,     3,     2,     1,     1,     1,     3,     1,     2,     4,
       3,     2,     2,     2,     2,     2,     1,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     5,     5,
       5,     3,     2,     3,     3,     2,     3,     2,     4,     3,
       3,     2,     3,     2,     3,     2,     3,     3,     2,     3,
       2,     4,     3,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     4,     5,     3,     2,     4,
       3,     4,     5,     3,     2,     4,     3,     4,     5,     3,
       2,     4,     3,     4,     5,     3,     2,     4,     3,     4,
       5,     3,     2,     4,     3,     4,     5,     3,     2,     4,
       3,     3,     3,     2,     3,     2,     3,     3,     3,     2,
       3,     2,     3,     3,     2,     3,     3,     2,     3,     2,
       3,     3,     3,     2,     5,     4,     4,     3,     3,     2,
       3,     3,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     2,     3,     4,     3,     3,     3,     3,     3,
       3,     3,     4,     3,     3,     2,     3,     3,     5,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     2,
       1,     0,     2,     2,     1,     2,     1,     2,     1,     3,
       1,     2,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:
#line 107 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              FILE * f = hfst::xfst::xfst_->xfst_fopen((yyvsp[-1].file), "r"); CHECK;
              hfst::xfst::xfst_->add_props(f);
              hfst::xfst::xfst_->xfst_fclose(f, (yyvsp[-1].file));
	    }
	    CHECK;
       }
#line 2145 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 7:
#line 116 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->add_props((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2154 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 8:
#line 120 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hxfsterror("NETWORK PROPERTY EDITOR unimplemented\n");
            return EXIT_FAILURE;
       }
#line 2163 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 9:
#line 125 "xfst-parser.yy" /* yacc.c:1646  */
    {
       	    hfst::xfst::xfst_->apply_up(stdin); CHECK;
       }
#line 2171 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 10:
#line 128 "xfst-parser.yy" /* yacc.c:1646  */
    {
       	    hfst::xfst::xfst_->apply_up((yyvsp[-1].text)); CHECK; free((yyvsp[-1].text));
       }
#line 2179 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 11:
#line 131 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->apply_up((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2188 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 12:
#line 135 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              FILE * f = hfst::xfst::xfst_->xfst_fopen((yyvsp[-1].file), "r"); CHECK;
              hfst::xfst::xfst_->apply_up(f);
              hfst::xfst::xfst_->xfst_fclose(f, (yyvsp[-1].file));
	    }
	    CHECK;
       }
#line 2202 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 13:
#line 144 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->apply_up((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2211 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 14:
#line 148 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->apply_down(stdin); CHECK;
       }
#line 2219 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 15:
#line 151 "xfst-parser.yy" /* yacc.c:1646  */
    {
       	    hfst::xfst::xfst_->apply_down((yyvsp[-1].text)); CHECK; free((yyvsp[-1].text));
       }
#line 2227 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 16:
#line 154 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->apply_down((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2236 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 17:
#line 158 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              FILE * f = hfst::xfst::xfst_->xfst_fopen((yyvsp[-1].file), "r"); CHECK;
              hfst::xfst::xfst_->apply_down(f);
              hfst::xfst::xfst_->xfst_fclose(f, (yyvsp[-1].file));
	    }
	    CHECK;
       }
#line 2250 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 18:
#line 167 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->apply_down((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2259 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 19:
#line 171 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->apply_med((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2268 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 20:
#line 175 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              FILE * f = hfst::xfst::xfst_->xfst_fopen((yyvsp[-1].file), "r"); CHECK;
              hfst::xfst::xfst_->apply_med(f);
              hfst::xfst::xfst_->xfst_fclose(f, (yyvsp[-1].file));
	    }
	    CHECK;
       }
#line 2282 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 21:
#line 184 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->apply_med((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2291 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 22:
#line 188 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->lookup_optimize(); CHECK;
       }
#line 2299 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 23:
#line 191 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->remove_optimization(); CHECK;
       }
#line 2307 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 24:
#line 195 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hxfsterror("unimplemetend ambiguous\n");
            return EXIT_FAILURE;
       }
#line 2316 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 25:
#line 199 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hxfsterror("unimplemetend ambiguous\n");
            return EXIT_FAILURE;
       }
#line 2325 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 26:
#line 203 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hxfsterror("unimplemetend ambiguous\n");
            return EXIT_FAILURE;
       }
#line 2334 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 27:
#line 208 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->define_alias((yyvsp[-2].name), (yyvsp[-1].text));
            free((yyvsp[-2].name));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2344 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 28:
#line 213 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->define_alias((yyvsp[-3].name), (yyvsp[-1].text));
            free((yyvsp[-3].name));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2354 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 29:
#line 218 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->define_list((yyvsp[-3].name), (yyvsp[-2].text));
            free((yyvsp[-3].name));
            free((yyvsp[-2].text)); CHECK;
       }
#line 2364 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 30:
#line 223 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->define_list((yyvsp[-2].name), (yyvsp[-1].list)[0], (yyvsp[-1].list)[1]);
            free((yyvsp[-2].name));
            free((yyvsp[-1].list)[0]);
            free((yyvsp[-1].list)[1]);
            free((yyvsp[-1].list)); CHECK;
       }
#line 2376 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 31:
#line 230 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->define((yyvsp[0].name));
            free((yyvsp[0].name)); CHECK;
       }
#line 2385 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 32:
#line 234 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->define((yyvsp[-1].name), (yyvsp[0].text));
            free((yyvsp[-1].name));
            free((yyvsp[0].text)); CHECK;
       }
#line 2395 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 33:
#line 239 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->define_function((yyvsp[-1].name), (yyvsp[0].text));
            free((yyvsp[-1].name));
            free((yyvsp[0].text)); CHECK;
       }
#line 2405 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 34:
#line 244 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->undefine((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2414 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 35:
#line 248 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->unlist((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2423 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 36:
#line 252 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->name_net((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2432 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 37:
#line 256 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->load_definitions((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2441 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 38:
#line 261 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->apropos((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2450 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 39:
#line 265 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->describe((yyvsp[-1].text)); CHECK;
       }
#line 2458 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 40:
#line 269 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->clear(); CHECK;
       }
#line 2466 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 41:
#line 272 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->pop(); CHECK;
       }
#line 2474 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 42:
#line 275 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->push((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2483 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 43:
#line 279 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->push(); CHECK;
       }
#line 2491 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 44:
#line 282 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->turn(); CHECK;
       }
#line 2499 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 45:
#line 285 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->rotate(); CHECK;
       }
#line 2507 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 46:
#line 288 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->load_stack((yyvsp[-1].file));
            free((yyvsp[-1].file)); CHECK;
       }
#line 2516 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 47:
#line 292 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->load_stack((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2525 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 48:
#line 296 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->load_stack((yyvsp[-2].name));
            free((yyvsp[-2].name)); CHECK;
       }
#line 2534 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 49:
#line 301 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->collect_epsilon_loops(); CHECK;
       }
#line 2542 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 50:
#line 304 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->compact_sigma(); CHECK;
       }
#line 2550 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 51:
#line 308 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->eliminate_flag((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2559 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 52:
#line 312 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->eliminate_flags(); CHECK;
       }
#line 2567 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 53:
#line 316 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->echo((yyvsp[0].text));
            free((yyvsp[0].text)); CHECK;
       }
#line 2576 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 54:
#line 320 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->quit((yyvsp[0].text));
            free((yyvsp[0].text));
            return EXIT_SUCCESS;
       }
#line 2586 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 55:
#line 325 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->hfst((yyvsp[0].text));
            free((yyvsp[0].text)); CHECK;
       }
#line 2595 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 56:
#line 329 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hxfsterror("source not implemented yywrap\n");
            free((yyvsp[-1].name));
            return EXIT_FAILURE;
       }
#line 2605 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 57:
#line 334 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->system((yyvsp[0].text));
            free((yyvsp[0].text)); CHECK;
       }
#line 2614 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 58:
#line 338 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->view_net(); CHECK;
            //hxfsterror("view not implemented\n");
            //return EXIT_FAILURE;
       }
#line 2624 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 59:
#line 344 "xfst-parser.yy" /* yacc.c:1646  */
    {
            int i = hfst::xfst::nametoken_to_number((yyvsp[-1].name));
            if (i != -1)
              hfst::xfst::xfst_->set((yyvsp[-2].name), i);
            else
              hfst::xfst::xfst_->set((yyvsp[-2].name), (yyvsp[-1].name));
            free((yyvsp[-2].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2638 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 60:
#line 353 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->show((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2647 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 61:
#line 357 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->show(); CHECK;
       }
#line 2655 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 62:
#line 360 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->twosided_flags(); CHECK;
       }
#line 2663 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 63:
#line 364 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_eq(); CHECK;
       }
#line 2671 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 64:
#line 367 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_funct(); CHECK;
       }
#line 2679 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 65:
#line 370 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_id(); CHECK;
       }
#line 2687 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 66:
#line 373 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_infinitely_ambiguous(); CHECK;
       }
#line 2695 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 67:
#line 376 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_lower_bounded(); CHECK;
       }
#line 2703 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 68:
#line 379 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_lower_uni(); CHECK;
       }
#line 2711 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 69:
#line 382 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_upper_bounded(); CHECK;
       }
#line 2719 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 70:
#line 385 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_upper_uni(); CHECK;
       }
#line 2727 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 71:
#line 388 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_nonnull(); CHECK;
       }
#line 2735 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 72:
#line 391 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_null(); CHECK;
       }
#line 2743 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 73:
#line 394 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_overlap(); CHECK;
       }
#line 2751 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 74:
#line 397 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_sublanguage(); CHECK;
       }
#line 2759 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 75:
#line 400 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_unambiguous(); CHECK;
       }
#line 2767 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 76:
#line 404 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_eq(true); CHECK;
       }
#line 2775 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 77:
#line 407 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_funct(true); CHECK;
       }
#line 2783 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 78:
#line 410 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_id(true); CHECK;
       }
#line 2791 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 79:
#line 413 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_lower_bounded(true); CHECK;
       }
#line 2799 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 80:
#line 416 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_lower_uni(true); CHECK;
       }
#line 2807 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 81:
#line 419 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_upper_bounded(true); CHECK;
       }
#line 2815 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 82:
#line 422 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_upper_uni(true); CHECK;
       }
#line 2823 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 83:
#line 425 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_nonnull(true); CHECK;
       }
#line 2831 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 84:
#line 428 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_null(true); CHECK;
       }
#line 2839 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 85:
#line 431 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_overlap(true); CHECK;
       }
#line 2847 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 86:
#line 434 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_sublanguage(true); CHECK;
       }
#line 2855 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 87:
#line 437 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->test_unambiguous(true); CHECK;
       }
#line 2863 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 88:
#line 441 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->substitute_named((yyvsp[-3].name), (yyvsp[-1].name)); // TODO!
            free((yyvsp[-3].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2873 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 89:
#line 446 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->substitute_label((yyvsp[-3].text), (yyvsp[-1].text));
            free((yyvsp[-3].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2883 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 90:
#line 451 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->substitute_symbol((yyvsp[-3].text), (yyvsp[-1].name));
            free((yyvsp[-3].text));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2893 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 91:
#line 457 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_aliases(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 2907 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 92:
#line 466 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_aliases(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 2915 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 93:
#line 469 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_arc_count(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 2929 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 94:
#line 478 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (strcmp((yyvsp[-1].name), "upper") && strcmp((yyvsp[-1].name), "lower"))
            {
                hxfsterror("should be upper or lower");
                free((yyvsp[-1].name));
                return EXIT_FAILURE;
            }
            hfst::xfst::xfst_->print_arc_count((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 2944 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 95:
#line 488 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_arc_count(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 2952 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 96:
#line 491 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
            {
	      std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_defined(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 2966 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 97:
#line 500 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_defined(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 2974 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 98:
#line 503 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
            {
	      std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_dir((yyvsp[-2].name), &oss);
              oss.close();
	    }
            free((yyvsp[-1].file)); CHECK;
       }
#line 2988 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 99:
#line 512 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_dir((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 2997 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 100:
#line 516 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_dir("*", &oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3011 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 101:
#line 525 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_dir("*", &hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3019 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 102:
#line 528 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
            {
	      std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_file_info(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3033 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 103:
#line 537 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_file_info(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3041 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 104:
#line 540 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_flags(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3055 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 105:
#line 549 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_flags(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3063 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 106:
#line 552 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_labels((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3072 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 107:
#line 556 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
            {
	      std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_labels(&oss);
              oss.close();
	      }
	      CHECK;
       }
#line 3086 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 108:
#line 565 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_labels(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3094 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 109:
#line 568 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_label_count(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3108 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 110:
#line 577 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_label_count(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3116 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 111:
#line 580 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_list((yyvsp[-2].name), &oss);
              oss.close();
	    }
            free((yyvsp[-2].name)); CHECK;
       }
#line 3130 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 112:
#line 589 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_list((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3139 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 113:
#line 593 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
            {
	      std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_list(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3153 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 114:
#line 602 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_list(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3161 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 115:
#line 605 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_longest_string(&oss);
              //hfst::xfst::xfst_fclose(f, $2);
              oss.close();
	    }
            CHECK;
       }
#line 3176 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 116:
#line 615 "xfst-parser.yy" /* yacc.c:1646  */
    {
            //hfst::xfst::xfst_->print_longest_string(&hfst::xfst::xfst_->get_output_stream());
            hfst::xfst::xfst_->print_longest_string(&hfst::xfst::xfst_->get_output_stream());
            CHECK;
       }
#line 3186 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 117:
#line 620 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
            {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_longest_string_size(&oss);
              //hfst::xfst::xfst_fclose(f, $2);
              oss.close();
	    }
            CHECK;
       }
#line 3201 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 118:
#line 630 "xfst-parser.yy" /* yacc.c:1646  */
    {
            //hfst::xfst::xfst_->print_longest_string_size(&hfst::xfst::xfst_->get_output_stream());
            hfst::xfst::xfst_->print_longest_string_size(&hfst::xfst::xfst_->get_output_stream());
            CHECK;
       }
#line 3211 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 119:
#line 635 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_name(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3225 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 120:
#line 644 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_name(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3233 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 121:
#line 647 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_shortest_string(&oss);
              //hfst::xfst::xfst_fclose(f, $2);
              oss.close();
	    }
            CHECK;
       }
#line 3248 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 122:
#line 657 "xfst-parser.yy" /* yacc.c:1646  */
    {
            //hfst::xfst::xfst_->print_shortest_string(&hfst::xfst::xfst_->get_output_stream());
            hfst::xfst::xfst_->print_shortest_string(&hfst::xfst::xfst_->get_output_stream());
            CHECK;
       }
#line 3258 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 123:
#line 662 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_shortest_string_size(&oss);
              //hfst::xfst::xfst_fclose(f, $2);
              oss.close();
	    }
            CHECK;
       }
#line 3273 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 124:
#line 672 "xfst-parser.yy" /* yacc.c:1646  */
    {
            //hfst::xfst::xfst_->print_shortest_string_size(&hfst::xfst::xfst_->get_output_stream());
            hfst::xfst::xfst_->print_shortest_string_size(&hfst::xfst::xfst_->get_output_stream());
            CHECK;
       }
#line 3283 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 125:
#line 677 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_lower_words((yyvsp[-2].name), hfst::xfst::nametoken_to_number((yyvsp[-1].name)), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-2].name)); free((yyvsp[-1].name)); CHECK;
       }
#line 3292 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 126:
#line 681 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_lower_words((yyvsp[-3].name), hfst::xfst::nametoken_to_number((yyvsp[-2].name)), &oss);
              //hfst::xfst::xfst_fclose(f, $4);
              oss.close();
	    }
	    free((yyvsp[-3].name)); free((yyvsp[-2].name));
            CHECK;
       }
#line 3308 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 127:
#line 692 "xfst-parser.yy" /* yacc.c:1646  */
    {
            int i = hfst::xfst::nametoken_to_number((yyvsp[-1].name));
            if (i != -1)
              hfst::xfst::xfst_->print_lower_words(NULL, i, &hfst::xfst::xfst_->get_output_stream());
            else
              hfst::xfst::xfst_->print_lower_words((yyvsp[-1].name), 0, &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name));
            CHECK;
       }
#line 3322 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 128:
#line 701 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_lower_words(NULL, 0, &hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3330 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 129:
#line 704 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              int i = hfst::xfst::nametoken_to_number((yyvsp[-2].name));
              if (i != -1)
                hfst::xfst::xfst_->print_lower_words(NULL, i, &oss);
              else
                hfst::xfst::xfst_->print_lower_words((yyvsp[-2].name), 0, &oss);
              //hfst::xfst::xfst_fclose(f, $3);
              oss.close();
	    }
            free((yyvsp[-2].name));
            CHECK;
       }
#line 3350 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 130:
#line 719 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_lower_words(NULL, 0, &oss);
              //hfst::xfst::xfst_fclose(f, $2);
              oss.close();
	    }
            CHECK;
       }
#line 3365 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 131:
#line 729 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_random_lower((yyvsp[-2].name), hfst::xfst::nametoken_to_number((yyvsp[-1].name)), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-2].name)); free((yyvsp[-1].name)); CHECK;
       }
#line 3374 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 132:
#line 733 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
            {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_random_lower((yyvsp[-3].name), hfst::xfst::nametoken_to_number((yyvsp[-2].name)), &oss);
              oss.close();
	      //hfst::xfst::xfst_fclose(f, $4);
	    }
	    free((yyvsp[-3].name)); free((yyvsp[-2].name));
            CHECK;
       }
#line 3390 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 133:
#line 744 "xfst-parser.yy" /* yacc.c:1646  */
    {
            int i = hfst::xfst::nametoken_to_number((yyvsp[-1].name));
            if (i != -1)
              hfst::xfst::xfst_->print_random_lower(NULL, i, &hfst::xfst::xfst_->get_output_stream());
            else
              hfst::xfst::xfst_->print_random_lower((yyvsp[-1].name), 15, &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name));CHECK;
       }
#line 3403 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 134:
#line 752 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_random_lower(NULL, 15, &hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3411 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 135:
#line 755 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              int i = hfst::xfst::nametoken_to_number((yyvsp[-2].name));
              if (i != -1)
                hfst::xfst::xfst_->print_random_lower(NULL, i, &oss);
              else
                hfst::xfst::xfst_->print_random_lower((yyvsp[-2].name), 15, &oss);
              //hfst::xfst::xfst_fclose(f, $3);
              oss.close();
	    }
            free((yyvsp[-2].name)); CHECK;
       }
#line 3430 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 136:
#line 769 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_random_lower(NULL, 15, &oss);
              //hfst::xfst::xfst_fclose(f, $2);
              oss.close();
	    }
            CHECK;
       }
#line 3445 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 137:
#line 779 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_upper_words((yyvsp[-2].name), hfst::xfst::nametoken_to_number((yyvsp[-1].name)), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-2].name)); CHECK;
       }
#line 3454 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 138:
#line 783 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_upper_words((yyvsp[-3].name), hfst::xfst::nametoken_to_number((yyvsp[-2].name)), &oss);
              //hfst::xfst::xfst_fclose(f, $4);
              oss.close();
	    }
	    free((yyvsp[-3].name)); free((yyvsp[-2].name));
            CHECK;
       }
#line 3470 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 139:
#line 794 "xfst-parser.yy" /* yacc.c:1646  */
    {
            int i = hfst::xfst::nametoken_to_number((yyvsp[-1].name));
            if (i != -1)
              hfst::xfst::xfst_->print_upper_words(NULL, i, &hfst::xfst::xfst_->get_output_stream());
            else
              hfst::xfst::xfst_->print_upper_words((yyvsp[-1].name), 0, &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3483 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 140:
#line 802 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_upper_words(NULL, 0, &hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3491 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 141:
#line 805 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              int i = hfst::xfst::nametoken_to_number((yyvsp[-2].name));
              if (i != -1)
                hfst::xfst::xfst_->print_upper_words(NULL, i, &oss);
              else
                hfst::xfst::xfst_->print_upper_words((yyvsp[-2].name), 0, &oss);
              oss.close();
	    }
            free((yyvsp[-2].name)); CHECK;
       }
#line 3509 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 142:
#line 818 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_upper_words(NULL, 0, &oss);
              oss.close();
	    }
            CHECK;
       }
#line 3523 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 143:
#line 827 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_random_upper((yyvsp[-2].name), hfst::xfst::nametoken_to_number((yyvsp[-1].name)), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-2].name)); free((yyvsp[-1].name)); CHECK;
       }
#line 3532 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 144:
#line 831 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_random_upper((yyvsp[-3].name), hfst::xfst::nametoken_to_number((yyvsp[-2].name)), &oss);
              oss.close();
	    }
	    free((yyvsp[-3].name)); free((yyvsp[-2].name));
            CHECK;
       }
#line 3547 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 145:
#line 841 "xfst-parser.yy" /* yacc.c:1646  */
    {
            int i = hfst::xfst::nametoken_to_number((yyvsp[-1].name));
            if (i != -1)
              hfst::xfst::xfst_->print_random_upper(NULL, i, &hfst::xfst::xfst_->get_output_stream());
            else
              hfst::xfst::xfst_->print_random_upper((yyvsp[-1].name), 15, &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3560 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 146:
#line 849 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_random_upper(NULL, 15, &hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3568 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 147:
#line 852 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
            {
	      std::ofstream oss((yyvsp[-1].file));
              int i = hfst::xfst::nametoken_to_number((yyvsp[-2].name));
              if (i != -1)
                hfst::xfst::xfst_->print_random_upper(NULL, i, &oss);
              else
                hfst::xfst::xfst_->print_random_upper((yyvsp[-2].name), 15, &oss);
              oss.close();
	    }
            free((yyvsp[-2].name)); CHECK;
       }
#line 3586 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 148:
#line 865 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_random_upper(NULL, 15, &oss);
              oss.close();
	    }
            CHECK;
       }
#line 3600 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 149:
#line 874 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_words((yyvsp[-2].name), hfst::xfst::nametoken_to_number((yyvsp[-1].name)), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-2].name)); free((yyvsp[-1].name)); CHECK;
       }
#line 3609 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 150:
#line 878 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_words((yyvsp[-3].name), hfst::xfst::nametoken_to_number((yyvsp[-2].name)), &oss);
              oss.close();
	    }
	    free((yyvsp[-3].name)); free((yyvsp[-2].name));
            CHECK;
       }
#line 3624 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 151:
#line 888 "xfst-parser.yy" /* yacc.c:1646  */
    {
            int i = hfst::xfst::nametoken_to_number((yyvsp[-1].name));
            if (i != -1)
              hfst::xfst::xfst_->print_words(NULL, i, &hfst::xfst::xfst_->get_output_stream());
            else
              hfst::xfst::xfst_->print_words((yyvsp[-1].name), 0, &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3637 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 152:
#line 896 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_words(NULL, 0, &hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3645 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 153:
#line 899 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              int i = hfst::xfst::nametoken_to_number((yyvsp[-2].name));
              if (i != -1)
                hfst::xfst::xfst_->print_words(NULL, i, &oss);
              else
                hfst::xfst::xfst_->print_words((yyvsp[-2].name), 0, &oss);
              oss.close();
	    }
            free((yyvsp[-2].name)); CHECK;
       }
#line 3663 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 154:
#line 912 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_words(NULL, 0, &oss);
              oss.close();
	    }
            CHECK;
       }
#line 3677 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 155:
#line 921 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_random_words((yyvsp[-2].name), hfst::xfst::nametoken_to_number((yyvsp[-1].name)), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-2].name)); free((yyvsp[-1].name)); CHECK;
       }
#line 3686 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 156:
#line 925 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_random_words((yyvsp[-3].name), hfst::xfst::nametoken_to_number((yyvsp[-2].name)), &oss);
              oss.close();
	    }
	    free((yyvsp[-3].name)); free((yyvsp[-2].name));
            CHECK;
       }
#line 3701 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 157:
#line 935 "xfst-parser.yy" /* yacc.c:1646  */
    {
            int i = hfst::xfst::nametoken_to_number((yyvsp[-1].name));
            if (i != -1)
              hfst::xfst::xfst_->print_random_words(NULL, i, &hfst::xfst::xfst_->get_output_stream());
            else
              hfst::xfst::xfst_->print_random_words((yyvsp[-1].name), 15, &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3714 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 158:
#line 943 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_random_words(NULL, 15, &hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3722 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 159:
#line 946 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              int i = hfst::xfst::nametoken_to_number((yyvsp[-2].name));
              if (i != -1)
                hfst::xfst::xfst_->print_random_words(NULL, i, &oss);
              else
                hfst::xfst::xfst_->print_random_words((yyvsp[-2].name), 15, &oss);
            oss.close();
	    }
            free((yyvsp[-2].name)); CHECK;
       }
#line 3740 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 160:
#line 959 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_random_words(NULL, 15, &oss);
              oss.close();
	    }
            CHECK;
       }
#line 3754 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 161:
#line 968 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_net((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3763 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 162:
#line 972 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_net(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3777 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 163:
#line 981 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_net(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3785 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 164:
#line 984 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_properties((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3794 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 165:
#line 988 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_properties(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3802 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 166:
#line 991 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_properties(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3816 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 167:
#line 1000 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_sigma((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3825 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 168:
#line 1004 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_sigma(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3839 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 169:
#line 1013 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_sigma(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3847 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 170:
#line 1016 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_sigma_count(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3861 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 171:
#line 1025 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_sigma_count(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3869 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 172:
#line 1028 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (strcmp((yyvsp[-1].name), "upper") && strcmp((yyvsp[-1].name), "lower"))
            {
                free((yyvsp[-1].name));
                hxfsterror("must be upper or lower\n");
                return EXIT_FAILURE;
            }
            hfst::xfst::xfst_->print_sigma_word_count((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3884 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 173:
#line 1038 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_sigma_word_count(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3898 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 174:
#line 1047 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_sigma_word_count(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3906 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 175:
#line 1050 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_size((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3915 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 176:
#line 1054 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_size(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3929 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 177:
#line 1063 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_size(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3937 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 178:
#line 1066 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_stack(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3951 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 179:
#line 1075 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->print_stack(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3959 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 180:
#line 1078 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_labelmaps(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3973 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 181:
#line 1088 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->write_dot((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3982 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 182:
#line 1092 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->write_dot(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3996 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 183:
#line 1101 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->write_dot(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4004 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 184:
#line 1104 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->write_function((yyvsp[-3].name), (yyvsp[-1].file));
            free((yyvsp[-3].name)); CHECK;
       }
#line 4013 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 185:
#line 1108 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->write_function((yyvsp[-2].name), 0);
            free((yyvsp[-2].name)); CHECK;
       }
#line 4022 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 186:
#line 1112 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->write_definition((yyvsp[-2].name), (yyvsp[-1].file));
            free((yyvsp[-2].name)); CHECK;
       }
#line 4031 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 187:
#line 1116 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->write_definition((yyvsp[-1].name), 0);
            free((yyvsp[-1].name)); CHECK;
       }
#line 4040 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 188:
#line 1120 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->write_definitions((yyvsp[-1].file)); CHECK;
       }
#line 4048 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 189:
#line 1123 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->write_definitions(0); CHECK;
       }
#line 4056 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 190:
#line 1126 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->write_stack((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 4065 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 191:
#line 1130 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->write_prolog(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 4079 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 192:
#line 1139 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].name)))
	    {
              std::ofstream oss((yyvsp[-1].name));
              hfst::xfst::xfst_->write_prolog(&oss);
              oss.close();
	    }
	    free((yyvsp[-1].name)); CHECK;
       }
#line 4093 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 193:
#line 1148 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->write_prolog(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4101 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 194:
#line 1151 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->write_spaced(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 4115 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 195:
#line 1160 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->write_spaced(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4123 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 196:
#line 1163 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->write_text(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 4137 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 197:
#line 1172 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->write_text(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4145 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 198:
#line 1176 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              FILE * f = hfst::xfst::xfst_->xfst_fopen((yyvsp[-1].file), "r"); CHECK;
              hfst::xfst::xfst_->read_props(f);
              hfst::xfst::xfst_->xfst_fclose(f, (yyvsp[-1].file));
	    }
	    CHECK;
       }
#line 4159 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 199:
#line 1185 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->read_props(stdin); CHECK;
       }
#line 4167 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 200:
#line 1188 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].name)))
	    {
              FILE * f = hfst::xfst::xfst_->xfst_fopen((yyvsp[-1].name), "r"); CHECK;
              hfst::xfst::xfst_->read_prolog(f);
              hfst::xfst::xfst_->xfst_fclose(f, (yyvsp[-1].name));
	    }
	    free((yyvsp[-1].name)); CHECK;
       }
#line 4181 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 201:
#line 1197 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->read_prolog(stdin); CHECK;
       }
#line 4189 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 202:
#line 1200 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->read_regex((yyvsp[0].text));
            free((yyvsp[0].text)); CHECK;
       }
#line 4198 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 203:
#line 1204 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              FILE * f = hfst::xfst::xfst_->xfst_fopen((yyvsp[-1].file), "r"); CHECK;
              hfst::xfst::xfst_->read_regex(f);
              hfst::xfst::xfst_->xfst_fclose(f, (yyvsp[-1].file));
	    }
	    CHECK;
       }
#line 4212 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 204:
#line 1213 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->read_regex((yyvsp[-2].text));
            free((yyvsp[-2].text)); CHECK;
       }
#line 4221 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 205:
#line 1217 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->read_spaced_from_file((yyvsp[-1].file));
            free((yyvsp[-1].file)); CHECK;
       }
#line 4230 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 206:
#line 1221 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->read_spaced_from_file((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 4239 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 207:
#line 1225 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->read_spaced((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 4248 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 208:
#line 1229 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->read_text_from_file((yyvsp[-1].file));
            free((yyvsp[-1].file)); CHECK;
       }
#line 4257 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 209:
#line 1233 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->read_text_from_file((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 4266 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 210:
#line 1237 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->read_text((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 4275 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 211:
#line 1241 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->read_lexc_from_file((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 4284 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 212:
#line 1245 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->read_lexc_from_file((yyvsp[-2].name));
            free((yyvsp[-2].name)); CHECK;
       }
#line 4293 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 213:
#line 1249 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->read_lexc_from_file(""); free((yyvsp[-1].text)); CHECK;
       }
#line 4301 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 214:
#line 1252 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->read_att_from_file((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 4310 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 215:
#line 1256 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->write_att(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4318 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 216:
#line 1259 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->write_att(&oss);
              oss.close();
	    }
            free((yyvsp[-1].file)); CHECK;
       }
#line 4332 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 217:
#line 1268 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].name)))
	    {
              std::ofstream oss((yyvsp[-1].name));
              hfst::xfst::xfst_->write_att(&oss);
              oss.close();
	    }
            free((yyvsp[-1].name)); CHECK;
       }
#line 4346 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 218:
#line 1277 "xfst-parser.yy" /* yacc.c:1646  */
    {
            // todo: handle input and output symbol tables
	    if (hfst::xfst::xfst_->check_filename((yyvsp[-3].name)))
	    {
              std::ofstream oss((yyvsp[-3].name));
              hfst::xfst::xfst_->write_att(&oss);
              oss.close();
	    }
            free((yyvsp[-3].name)); free((yyvsp[-2].name)); free((yyvsp[-1].name)); CHECK;
       }
#line 4361 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 219:
#line 1288 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->cleanup_net(); CHECK;
       }
#line 4369 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 220:
#line 1291 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->complete_net(); CHECK;
       }
#line 4377 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 221:
#line 1294 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->compose_net(); CHECK;
       }
#line 4385 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 222:
#line 1297 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->concatenate_net(); CHECK;
       }
#line 4393 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 223:
#line 1300 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->minus_net(); CHECK;
       }
#line 4401 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 224:
#line 1303 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->crossproduct_net(); CHECK;
       }
#line 4409 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 225:
#line 1306 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->minimize_net(); CHECK;
       }
#line 4417 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 226:
#line 1309 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->determinize_net(); CHECK;
       }
#line 4425 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 227:
#line 1312 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->epsilon_remove_net(); CHECK;
       }
#line 4433 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 228:
#line 1315 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->prune_net(); CHECK;
       }
#line 4441 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 229:
#line 1318 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->ignore_net(); CHECK;
       }
#line 4449 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 230:
#line 1321 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->intersect_net(); CHECK;
       }
#line 4457 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 231:
#line 1324 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->inspect_net(); CHECK;
       }
#line 4465 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 232:
#line 1327 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->invert_net(); CHECK;
       }
#line 4473 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 233:
#line 1330 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->lower_side_net(); CHECK;
       }
#line 4481 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 234:
#line 1333 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->upper_side_net(); CHECK;
       }
#line 4489 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 235:
#line 1336 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->negate_net(); CHECK;
       }
#line 4497 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 236:
#line 1339 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->one_plus_net(); CHECK;
       }
#line 4505 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 237:
#line 1342 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->zero_plus_net(); CHECK;
       }
#line 4513 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 238:
#line 1345 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->optional_net(); CHECK;
       }
#line 4521 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 239:
#line 1348 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->reverse_net(); CHECK;
       }
#line 4529 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 240:
#line 1351 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->shuffle_net(); CHECK;
       }
#line 4537 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 241:
#line 1354 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->sigma_net(); CHECK;
       }
#line 4545 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 242:
#line 1357 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->sort_net(); CHECK;
       }
#line 4553 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 243:
#line 1360 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->substring_net(); CHECK;
       }
#line 4561 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 244:
#line 1363 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->union_net(); CHECK;
       }
#line 4569 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 245:
#line 1366 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->label_net(); CHECK;
       }
#line 4577 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 246:
#line 1369 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->compile_replace_lower_net(); CHECK;
       }
#line 4585 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 247:
#line 1372 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->compile_replace_upper_net(); CHECK;
       }
#line 4593 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 248:
#line 1375 "xfst-parser.yy" /* yacc.c:1646  */
    {
            hfst::xfst::xfst_->prompt(); CHECK;
       }
#line 4601 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 249:
#line 1378 "xfst-parser.yy" /* yacc.c:1646  */
    {
            if ( hfst::xfst::xfst_->unknown_command((yyvsp[-1].name)) != 0)
              {
                hxfsterror("Command not recognized.\n");
                free((yyvsp[-1].name));
                YYABORT;
              }
            free((yyvsp[-1].name));
       }
#line 4615 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 252:
#line 1391 "xfst-parser.yy" /* yacc.c:1646  */
    {
                    (yyval.text) = static_cast<char*>(malloc(sizeof(char)*strlen((yyvsp[-1].text))+strlen((yyvsp[0].name))+2));
                    char* r = (yyval.text);
                    char* s = (yyvsp[-1].text);
                    while (*s != '\0')
                    {
                        *r = *s;
                        r++;
                        s++;
                    }
                    *r = ' ';
                    r++;
                    s = (yyvsp[0].name);
                    while (*s != '\0')
                    {
                        *r = *s;
                        r++;
                        s++;
                    }
                    *r = '\0';
                    free((yyvsp[0].name));
                }
#line 4642 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 253:
#line 1413 "xfst-parser.yy" /* yacc.c:1646  */
    {
                    (yyval.text) = (yyvsp[-1].text);
                }
#line 4650 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 254:
#line 1416 "xfst-parser.yy" /* yacc.c:1646  */
    {
                    (yyval.text) = (yyvsp[0].name);
                }
#line 4658 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 255:
#line 1421 "xfst-parser.yy" /* yacc.c:1646  */
    {
                (yyval.text) = static_cast<char*>(malloc(sizeof(char)*strlen((yyvsp[-1].text))+strlen((yyvsp[0].name))+2));
                char* s = (yyvsp[-1].text);
                char* r = (yyval.text);
                while (*s != '\0')
                {
                    *r = *s;
                    r++;
                    s++;
                }
                *r = ' ';
                r++;
                s = (yyvsp[0].name);
                while (*s != '\0')
                {
                    *r = *s;
                    r++;
                    s++;
                }
                *r = '\0';
                free((yyvsp[-1].text)); free((yyvsp[0].name));
             }
#line 4685 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 256:
#line 1443 "xfst-parser.yy" /* yacc.c:1646  */
    {
                (yyval.text) = (yyvsp[0].name);
             }
#line 4693 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 257:
#line 1448 "xfst-parser.yy" /* yacc.c:1646  */
    {
                (yyval.text) = static_cast<char*>(malloc(sizeof(char)*strlen((yyvsp[-1].text))+strlen((yyvsp[0].name))+4));
                char* s = (yyvsp[-1].text);
                char* r = (yyval.text);
                while (*s != '\0')
                {
                    *r = *s;
                    r++;
                    s++;
                }
                *r = ' ';
                r++;
                s = (yyvsp[0].name);
                *r = '"';
                r++;
                while (*s != '\0')
                {
                    *r = *s;
                    r++;
                    s++;
                }
                *r = '"';
                r++;
                *r = '\0';
                free((yyvsp[-1].text)); free((yyvsp[0].name));
             }
#line 4724 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 258:
#line 1474 "xfst-parser.yy" /* yacc.c:1646  */
    {
                (yyval.text) = static_cast<char*>(malloc(sizeof(char)*strlen((yyvsp[0].name))+3));
                char* s = (yyvsp[0].name);
                char* r = (yyval.text);
                *r = '"';
                r++;
                while (*s != '\0')
                {
                    *r = *s;
                    r++;
                    s++;
                }
                *r = '"';
                r++;
                *r = '\0';
                free((yyvsp[0].name));
             }
#line 4746 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 259:
#line 1493 "xfst-parser.yy" /* yacc.c:1646  */
    {
                (yyval.text) = strdup((std::string((yyvsp[-2].name)) + std::string(":") + std::string((yyvsp[0].name))).c_str());
                free((yyvsp[-2].name)); free((yyvsp[0].name));
                }
#line 4755 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 260:
#line 1497 "xfst-parser.yy" /* yacc.c:1646  */
    {
                (yyval.text) = (yyvsp[0].name);
                }
#line 4763 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 261:
#line 1502 "xfst-parser.yy" /* yacc.c:1646  */
    {
                (yyval.text) = static_cast<char*>(malloc(sizeof(char)*strlen((yyvsp[-1].text))+strlen((yyvsp[0].text))+2));
                char* s = (yyvsp[-1].text);
                char* r = (yyval.text);
                while (*s != '\0')
                {
                    *r = *s;
                    r++;
                    s++;
                }
                *r = ' ';
                r++;
                s = (yyvsp[0].text);
                while (*s != '\0')
                {
                    *r = *s;
                    r++;
                    s++;
                }
                *r = '\0';
                free((yyvsp[-1].text)); free((yyvsp[0].text));
             }
#line 4790 "xfst-parser.cc" /* yacc.c:1646  */
    break;

  case 262:
#line 1524 "xfst-parser.yy" /* yacc.c:1646  */
    {
                (yyval.text) = (yyvsp[0].text);
             }
#line 4798 "xfst-parser.cc" /* yacc.c:1646  */
    break;


#line 4802 "xfst-parser.cc" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1528 "xfst-parser.yy" /* yacc.c:1906  */


// oblig. declarations
extern FILE* hxfstin;
int hxfstparse(void);

// gah, bison/flex error mechanism here
void
hxfsterror(const char* text)
{
    hfst::xfst::xfst_->error() << text << std::endl;
    hfst::xfst::xfst_->flush(&hfst::xfst::xfst_->error());
    //fprintf(stderr,  "%s\n", text);
}


// vim: set ft=yacc:
